/*
 * Copyright (c) CompanyNameMagicTag 2012-2022. All rights reserved.
 * Description: media_mem_trace.h
 * Author: AuthorNameMagicTag
 * Create: 2022-06-30
 */
#ifndef _MEDIA_MEM_TRACE_H
#define _MEDIA_MEM_TRACE_H

#include <linux/types.h>

#define MMA_TRACE_LEVEL0 0
#define MMA_TRACE_LEVEL1 1
#define MMA_TRACE_LEVEL2 2

#ifdef CONFIG_MEDIA_MEM
void mma_trace_alloc_start(int level, const char *fun, int line, const void *bufname, const char* msg, ...);
void mma_trace_alloc_end(int level, const char *fun, int line, const void *bufname, const char* msg, ...);
void mma_trace_hook_start(int level, const char *fun, int line, const void *bufname, const char* msg, ...);
void mma_trace_hook_end(int level, const char *fun, int line, const void *bufname, const char* msg, ...);
void mma_trace_custom_start(int level, const char *fun, int line, const void *bufname, const char* msg, ...);
void mma_trace_custom_end(int level, const char *fun, int line, const void *bufname, const char* msg, ...);
const void *mma_handle_get_name_by_fd(int fd);
const void *mma_handle_get_name_by_handle(const void *handle);

#else
static inline void mma_trace_alloc_start(int level, const char *fun, int line,
	const void *bufname, const char* msg, ...)
{
	return;
}
static inline void mma_trace_alloc_end(int level, const char *fun, int line, const void *bufname, const char* msg, ...)
{
	return;
}

static inline void mma_trace_hook_start(int level, const char *fun, int line, const void *bufname, const char* msg, ...)
{
	return;
}
static inline void mma_trace_hook_end(int level, const char *fun, int line, const void *bufname, const char* msg, ...)
{
	return;
}

static inline void mma_trace_custom_start(int level, const char *fun, int line,
	const void *bufname, const char* msg, ...)
{
	return;
}
static inline void mma_trace_custom_end(int level, const char *fun, int line, const void *handle, const char* msg, ...)
{
	return;
}

static inline const void *mma_handle_get_name_by_fd(int fd)
{
	return NULL;
}

static inline const void *mma_handle_get_name_by_handle(const void *handle)
{
	return NULL;
}
#endif

#endif
